/*
 * 
 * array_i.h
 *
 */

#ifndef ARRAY_I_H
#define ARRAY_I_H

#include <iostream.h>
#include <stdlib.h>

template<class T> inline array<T>::array(int cluster_size)
{
  _data         = NULL;
  _remaining    = 0;
  _n_cluster    = 0;
  _idx          = 0;
  _cluster_size = cluster_size;
}

template<class T> inline T& array<T>::operator[](int idx)
{
  return _data[idx];
}

template<class T> inline int array<T>::Push(T* x)
{
  if(!_remaining)
    {
      _n_cluster++;
      T* _new_data = new T[_n_cluster * _cluster_size];
      for(int i=0; i<_idx; i++)
	_new_data[i] = _data[i];
      if(_data)
	delete[] _data;
      _data = _new_data;
      _remaining = _cluster_size;
    }
  _remaining--;
  _data[_idx++] = *x;
  return _idx - 1;
}

template<class T> inline int array<T>::Size(void)
{
  return _idx;
}

template<class T> inline T& array<T>::Top(void)
{
  return _data[_idx - 1];
}

#endif
