
#include "gport.h"
#include "number.h"
#include "observer.h"
#include "world.h"
#include <signal.h>

World W;


void Column(Number x, Number y, Number radius, int nbr, int reverse = 0)
{
  int i, j;
  int idx = W.Vertice().Size();

  for(i=0; i < nbr; i++)
    {
      Number xx = x;
      Number yy = y;
      Number u = i;
      u /= nbr;

      Number s = WSin(u);
      Number c = WCos(u);

      xx.mac(c,radius);
      yy.mac(s,radius);

      W.AddVertex(xx, yy);
    }

  for(i=0; i<nbr; i++)
    {
      j = (i+1) % nbr;
      if(reverse)
	W.AddWall(j + idx, i + idx);
      else
	W.AddWall(i + idx, j + idx);
    }

}

void Window()
{
  W.Walls().Top().SetFlags(W_WINDOW);
}

int main()
{


  WPoint P;
  P.x = 0;
  P.y = 0;

  int i;




  GraphicPort *GP = MakeGraphicPort("E.N.D.", 320, 200, MSG_ALL);

  if(GP->BitsPerPixel() != 8)
    {
      cerr << "Sorry, no multidepth support for this program" << endl
           << "requires 8bpp !" << endl;
    }

  int Direct = 0; //GP->SingleBuffer();

  for(i=0; i<64; i++)
    GP->MapColor(i, i << 2, i << 2, i << 2);


// Room 1

  Column(-50,-50,10,7);
  Column(-50, 50,10,7);
  Column( 50,-50,10,7);
  Column( 50, 50,10,7);
  Column(0,0,200,7,1);

  W.Walls().Top().SetFlags(W_WINDOW); // let's try this window stuff !!




// Mrs & Mr Broussaudier's sweet home
/*
W.AddVertex(-200,0);
W.AddVertex(-200,70);
W.AddVertex(-200,130);
W.AddVertex(-200,200);
W.AddVertex(-200,300);
W.AddVertex(-200,380);
W.AddVertex(-200,400);
W.AddVertex(30,400);
W.AddVertex(200,400);
W.AddVertex(200,300);
W.AddVertex(200,250);
W.AddVertex(200,200);
W.AddVertex(200,180);
W.AddVertex(200,120);
W.AddVertex(200,100);
W.AddVertex(200,50);
W.AddVertex(200,20);
W.AddVertex(200,0);
W.AddVertex(30,0);
W.AddVertex(-30,0);
W.AddVertex(-30,200);
W.AddVertex(-30,110);
W.AddVertex(-30,70);
W.AddVertex(30,300);
W.AddVertex(-30,300);
W.AddVertex(-30,280);
W.AddVertex(-30,220);
W.AddVertex(30,200);
W.AddVertex(30,220);
W.AddVertex(30,280);
W.AddVertex(30,100);
W.AddVertex(30,110);
W.AddVertex(30,150);
W.AddVertex(170,100);
W.AddVertex(130,100);
W.AddVertex(100,0);
W.AddVertex(100,100);
W.AddVertex(30,30);
W.AddVertex(30,70);


W.AddWall(0,1);
W.AddWall(1,2); Window();
W.AddWall(2,4);
W.AddWall(4,5); Window();
W.AddWall(5,6);
W.AddWall(6,8);
W.AddWall(8,9);
W.AddWall(9,10); Window();
W.AddWall(10,12);
W.AddWall(12,13); Window();
W.AddWall(13,15);
W.AddWall(15,16); Window();
W.AddWall(16,17);
W.AddWall(17,18);
W.AddWall(18,19);  // Door
W.AddWall(19,0);
W.AddWall(3,20);
W.AddWall(20,21);
W.AddWall(22,19);
W.AddWall(7,23);
W.AddWall(23,24);
W.AddWall(24,25);
W.AddWall(26,20);
W.AddWall(20,3);
W.AddWall(11,27);
W.AddWall(27,28);
W.AddWall(29,7);
W.AddWall(30,31);
W.AddWall(32,27);
W.AddWall(27,11);
W.AddWall(14,33);
W.AddWall(34,30);
W.AddWall(35,36);
W.AddWall(36,34);
W.AddWall(33,14);
W.AddWall(18,37);
W.AddWall(38,30);
W.AddWall(30,36);
W.AddWall(36,35);

W.AddWall(19,22);
W.AddWall(21,20);
W.AddWall(20,26);
W.AddWall(25,24);
W.AddWall(24,23);
W.AddWall(23,29);
W.AddWall(28,27);
W.AddWall(27,32);
W.AddWall(31,38);
W.AddWall(37,18);
*/


/*
// The Broussau's external faces

W.AddWall(0,19);
W.AddWall(18,17);
W.AddWall(17,16);
W.AddWall(16,15); Window();
W.AddWall(15,13);
W.AddWall(13,12); Window();
W.AddWall(12,10);
W.AddWall(10,9);  Window();
W.AddWall(9,8);
W.AddWall(8,6);
W.AddWall(6,5);
W.AddWall(5,4);   Window();
W.AddWall(4,2);
W.AddWall(2,1);   Window();
W.AddWall(1,0);
 
*/

/*
int  idx = W.AddVertex( 15,-10);
        W.AddVertex( 15, 10);
        W.AddVertex( 10, 15);
        W.AddVertex(-10, 15);
        W.AddVertex(-15, 10);
        W.AddVertex(-15,-10);
        W.AddVertex(-10,-15);
        W.AddVertex( 10,-15);

  W.AddWall(idx,  idx+1);
  W.AddWall(idx+2,idx+3);
  W.AddWall(idx+4,idx+5);
  W.AddWall(idx+6,idx+7);


  Column( 10, 10, 5, 16, 0 );
  Column(-10, 10, 5, 16, 0 );
  Column( 10,-10, 5, 16, 0 );
  Column(-10,-10, 5, 16, 0 );
*/

  signal(SIGFPE,SIG_IGN);

  WVector L(10,10);
  W.Setup();
  W.Lighting(L);
  Observer O(P, 0, 180.0 * (double)GP->Width() / 320.0, GP->Width());

  Number PMinAmp =  10;
  Number NMinAmp = -10;

  cerr << "vertice= " << W.Vertice().Size() << " walls= " << W.Walls().Size() << "\n";

  while(!GP->GetKey())
    {
      int x,y;
      WRay TheMove;
      Number  amp;
      Number Camp;

      GP->GetMouse(&x,&y);
      O.Rotate(((double)x - (GP->Width() >> 1)) / (GP->Width() * 10.0));

      amp = (double)((GP->Height() >> 1) - y) / (GP->Width() >> 3);

      if(amp.gt())
	Camp = amp > PMinAmp ? amp : PMinAmp;
      else
	Camp = amp < NMinAmp ? amp : NMinAmp;

      O.GetMove(Camp, &TheMove);
      if(!W.Isect(TheMove))
	O.Move(amp);
      W.Draw(O,GP);

      if(!Direct)
	GP->SwapBuffers();

    }

  return 0;
}







