/*
 *
 * number_i.h
 *
 */

#ifndef NUMBER_I_H
#define NUMBER_I_H


inline Number::Number(void)
{
}


inline Number::Number(const int u)
{
  x = ((long)u) << NUMBER_SHIFT;
}


inline Number::Number(const long int u)
{
  x = u << NUMBER_SHIFT;
}

inline Number::Number(const double u)
{
  x = (long)((double)(1 << NUMBER_SHIFT) * u);
}

inline Number::Number(const float u)
{
  x = (long)((double)(1 << NUMBER_SHIFT) * u);
}


inline Number::operator long int()
{
  return x >> NUMBER_SHIFT;
}


inline Number::operator double()
{
    return x >> NUMBER_SHIFT;
}


inline Number::operator int()
{
    return x >> NUMBER_SHIFT;
}


inline Number::operator float()
{
    return x >> NUMBER_SHIFT;
}
  
inline Number Number::operator+=(const Number u)
{
  x += u.x;
  return *this;
}

inline Number Number::operator-=(const Number u)
{
  x -= u.x;
  return *this;
}

inline Number Number::operator*=(const Number u)
{
  x *= u.x;
  x = x >> NUMBER_SHIFT;
  return *this;
}

inline Number Number::operator/=(const Number u)
{
  x =  (x << NUMBER_SHIFT) / u.x;
  return *this;
}

inline Number Number::mac(const Number u, const Number v)
{
  Number w = u;
  w *= v;
  *this += w;
  return *this;
}

inline Number Number::msc(const Number u, const Number v)
{
  Number w = u;
  w *= v;
  *this -= w;
  return *this;
}

inline  Number Number::mld(const Number u, const Number v)
{
  Number w = u;
  w *= v;
  *this = w;
  return *this;
}

inline Number Number::neg(void)
{
  x = -x;
  return *this;
}

inline int Number::lw(void)
{
  return (x < 0);
}

inline int Number::le(void)
{
  return (x <=0);
}

inline int Number::gt(void)
{
  return (x > 0);
}

inline int Number::ge(void)
{
  return (x >= 0);
}

inline Number WSin(const Number u)
{
  Number v;
#ifdef PRECISION_OVERRIDE
  v.x = u.x << (8 - NUMBER_SHIFT);
#else
  v.x = u.x >> (NUMBER_SHIFT - 8);
#endif
  v.x = SIN(v.x);
  v.x = v.x >> ( SIN_SHIFT - NUMBER_SHIFT);
  return v;
}

inline Number WCos(const Number u)
{
  Number v;
#ifdef PRECISION_OVERRIDE
  v.x = u.x << (8 - NUMBER_SHIFT);
#else
  v.x = u.x >> (NUMBER_SHIFT - 8);
#endif
  v.x = COS(v.x);
  v.x = v.x >> ( SIN_SHIFT - NUMBER_SHIFT);
  return v;
}

inline ostream& operator << (ostream& o, const Number u)
{
  return o << (double)(u.x)/(double)(1 << NUMBER_SHIFT);
}

inline int operator < (const Number u, const Number v)
{
  return  u.x < v.x;
}

inline int operator <= (const Number u, const Number v)
{
  return  u.x <= v.x;
}

inline int operator > (const Number u, const Number v)
{
  return  u.x > v.x;
}

inline int operator >= (const Number u, const Number v)
{
  return  u.x >= v.x;
}

#endif
