/*
 *
 * observer.h
 *
 */

#ifndef OBSERVER_H
#define OBSERVER_H

#include "number.h"
#include "wdefs.h"

const W_MAX_WIDTH = 1024;


class Observer
{
 public:
  Observer(const WPoint pos, const Number angle, const Number dist_obs_scr,const int width);
  void SetWidth(int width);
  int  GetWidth(void);
  void Move(WVector V);
  void Move(Number amp);
  void Rotate(Number angle);
  void SetAngle(Number angle);
  void Launch(int x, WRay *R);
  int  WallHeight(int x, Number t);
  void GetMove(Number amp, WRay *R);

 public:

  void compute_orig_launch_table(void);
  void compute_launch_table(void);

  WVector _orig_launch_table[W_MAX_WIDTH];
  WVector _launch_table[W_MAX_WIDTH];
  Number  _angle;
  WPoint  _pos;
  int     _width;
  Number  _dist_obs_scr;
  WVector _last_move;
};

#include "observer_i.h"


#endif
