/*
 *
 * room_i.h
 *
 */

#ifndef ROOM_I_H
#define ROOM_I_H

inline Room::Room(void)
{
}

inline array<Wall *>& Room::Walls(void)
{
  return _wall;
}
 
inline array<Door>& Room::Doors(void)
{
  return _door;
}

inline int Room::Isect(WRay &R)
{
  int i;
  for(i=0; i < _wall.Size(); i++)
    if(_wall[i]->Isect(R))
	return 1;

  return 0;
}

inline int Room::Isect(WRay &R, Room* &room)
{
  int i;

  room = this;

  if(Isect(R))
    return 1;

  for(i=0; i < _door.Size(); i++)
    {
      if(_door[i].Isect(R))
	{
	  if(_door[i].GetRoom()->Isect(R))
	      return 1;
	  else
	    {
	      room = _door[i].GetRoom();
	      return 0;
	    }
	}
    }

  return 0;
}

inline int Room::Isect(WRay &R, IsectInfo &II)
{
  int    i;
  Room*  room       = this;
  int    isect_loop = 1;

  while(isect_loop)
    {
      for(i=0; i<room->_wall.Size(); i++)
	if(room->_wall[i]->Isect(R,II))
	  return 1;

      isect_loop = 0;

      for(i=0; i<room->_door.Size(); i++)
	if(room->_door[i].Isect(R)) 
	  {
	    room       = _door[i].GetRoom();
	    isect_loop = 1;
	    break;
	  }
    }
  return 0;
}


#endif
