/*
 *
 * wdefs.h
 *
 */


#ifndef WDEFS_H
#define WDEFS_H

#include "number.h"
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include "gport.h"
#include "array.h"

class WVector;

class WPoint
{
 public:
  Number x,y;
  WPoint(void);
  WPoint(const Number xx, const Number yy);
  WPoint& operator += (const WVector *);
};

class WVertex : public WPoint
{
 public:
  WVertex(void);
  WVertex(const Number xx, const Number yy);
  WVertex(const Number xx, const Number yy, const int c1, const int c2);
  int _upper_col, _lower_col;
};


class WVector
{
 public:
  Number x,y;
  WVector(void);
  WVector(const Number xx, const Number yy);
  WVector(const WPoint &P1, const WPoint &P2);
  void Normalize(void);
};

inline Number operator*(WVector &V1, WVector &V2);
inline Number operator%(WVector &V1, WVector &V2); // Det

class WRay
{
 public:
  WRay(void);
  WRay(const WPoint& PP, const WVector& VV);
  WPoint  P;
  WVector V;
};

class Wall;

class IsectInfo
{
 public:
  IsectInfo(void);
  Wall  *wall;
  Number t,u;
  int    flag;
};

const int W_WINDOW = 1;

class Wall
{
 public:
  Wall(int idx1, int idx2, int color = 0);
  Wall(void);
  int Isect(WRay &R, IsectInfo &II);
  int Isect(WRay &R);
  void Setup(array<WVertex> &vertice);
  void SetFlags(int flags);

  WVertex *_P1;
  WVertex *_P2;
  WVector _P1P2;

  int _idx1;
  int _idx2;

  int _color;
  int _coldiff;

  int _flags;

};

#include "wdefs_i.h"


#endif
