/*
 * 
 * world.h
 *
 */


#ifndef WORLD_H
#define WORLD_H

#include "wdefs.h"
#include "observer.h"
#include "gport.h"
#include "array.h"
#include "room.h"

class World
{
 public:
  World(void);

  int  AddVertex(Number x, Number y, int c1 = 0, int c2 = 0);
  int  AddWall(int v1, int v2, int color = 0);

  void Draw(Observer& O, GraphicPort *GP);
  int  Isect(WRay &R);

  void Lighting(WVector &Light);
  void Lighting(WPoint  &Light);

  array<Wall>&    Walls(void);
  array<WVertex>& Vertice(void);

  void Setup(void);

 private:
  array<Wall>    _wall;
  array<WVertex> _vertex;

};

#include "world_i.h"

#endif

