/*
 *
 * flags_i.h
 *
 */

#ifndef FLAGS_I_H
#define FLAGS_I_H


inline Flags::Flags(const FlagSet init)
{
  _flags = init;
}

inline Flag Flags::Get(const Flag f) const
{
  return _flags & (1 << (f-1));
}

inline void Flags::Set(const Flag f)
{
  _flags |= (1 << (f-1));
}

inline void Flags::Reset(const Flag f)
{
  _flags &= ~(1 << (f-1));
}

inline FlagSet Flags::GetAll(void) const
{
  return _flags;
}

inline void Flags:: SetAll(const FlagSet fs)
{
  _flags = fs;
}

#endif
