/*
 *
 * gdefs.h
 *
 */

#ifndef GDEFS_H
#define GDEFS_H

#include <assert.h>
#include <iostream.h>
#include "flags.h"

const int  GP_COLORMAP_SZ = 256;

typedef int            ScrCoord;
typedef unsigned char  ColorIndex;
typedef int            ColorCode;
typedef unsigned long  ZCoord;
typedef long           SZCoord;
typedef int            TexCoord;
typedef int            ColorComponent;
typedef unsigned long  PixelValue;
typedef unsigned char  PixelValue8;
typedef unsigned short PixelValue15;
typedef unsigned long  PixelValue32;

typedef char          Point; // dummy - will be a class later on

const int VF_NONE = 0;
const int VF_CLIP = 1;

class Vertex
{
 public:
  ScrCoord       x,y;
  SZCoord        z;
  ColorCode      c;
  ColorComponent r,g,b,a;
  TexCoord       X,Y;

  Point          geometry;

  Flags          flags;
};


inline ostream& operator<<(ostream& o, Vertex& v)
{
  return o << "[" << v.x << " " << v.y << " " << v.z << "]\n";
};

class VertexAttributes
{
 public:
  ZCoord         z;
  ColorCode      c;
  ColorComponent r,g,b,a;
  TexCoord       X,Y;
};

const int VC_ENTRIES = 50;

#define NEW_ARRAY(x,n) (x *)malloc((n * sizeof(x)))

#endif




