/*
 *
 * gport_i.h
 *
 */

#ifndef GPORT_I_H
#define GPORT_I_H

inline GraphicPort::GraphicPort(char *name, ScrCoord width, 
				ScrCoord height, int verbose_level)
    {
      _name            = name;
      _width           = width;
      _height          = height;
      _graph_mem       = NULL;
      _z_mem           = NULL;
      _error_code      = GPE_OK;
      _bits_per_pixel  = 0;
      _bytes_per_pixel = 0;
      _proc_name       = "GraphicPort";
      _R_mask          = 0;
      _G_mask          = 0;
      _B_mask          = 0;
      Verbose(verbose_level);
    };


inline ColorIndex* GraphicPort::GraphMem(void) const {return _graph_mem;       }
inline ColorIndex* GraphicPort::Colormap(void) const {return _colormap;        }
inline ZCoord*     GraphicPort::ZMem(void)     const {return _z_mem;           }

inline ScrCoord    GraphicPort::Width(void)    const {return _width;     } 
inline ScrCoord    GraphicPort::Height(void)   const {return _height;    } 
inline void        GraphicPort::GetGeometry(ScrCoord *w, ScrCoord *h) const 
{
  *w = _width;
  *h = _height;
}

inline int         GraphicPort::BytesPerLine(void)  const {return _bytes_per_line; }
inline int         GraphicPort::BitsPerPixel(void)  const {return _bits_per_pixel; }
inline int         GraphicPort::BytesPerPixel(void) const {return _bytes_per_pixel;}
inline Rect&       GraphicPort::Clip(void) {return _clip;}
inline int         GraphicPort::ErrorCode(void) const { return _error_code; }

#endif

