/*
 *
 * gproc.h
 *
 */

#ifndef GPROC_H
#define GPROC_H

#include "gdefs.h"
#include "gcomp.h"
#include "gport.h"


const Flag GA_RGB     = 1;
const Flag GA_GOURAUD = 2;
const Flag GA_DITHER  = 3;
const Flag GA_ZBUFFER = 4;
const Flag GA_ALPHA   = 5;
const Flag GA_TEXTURE = 6;

const Flag GA_MAX     = 6;

class GraphicProcessor : public GraphicComponent
{
 protected:
  GraphicPort *_gport;


// delegated features


 public:
  ScrCoord    Width(void)        const;
  ScrCoord    Height(void)       const;
  ColorIndex* GraphMem(void)     const;
  ColorIndex* Colormap(void)     const;
  ZCoord*     ZMem(void)         const;
  int         BytesPerLine(void) const;
  int         BitsPerPixel(void) const;
  int         RedMask(void)      const;
  int         GreenMask(void)    const;
  int         BlueMask(void)     const;
  Rect&       Clip(void);
  
  GraphicProcessor(GraphicPort* gport);
  virtual ~GraphicProcessor(void);

  void ColormapMode(void);
  void RGBMode(void);
  void Gouraud(int yes = 1);
  void Flat(void);
  void Dither(int yes = 1);
  void ZBuffer(int yes = 1);
  void Alpha(int yes = 1);
  void Texture(int yes = 1);
};

#include "gproc_i.h"

#endif
