/*
 *
 * polyeng_i.h
 *
 */

#ifndef POLYENG_I_H
#define POLYENG_I_H


inline void PolygonEngine::Push(Vertex *v)
{
  _p1.Push(v);
}

inline void PolygonEngine::Reset(void)
{
  _p1.Reset();
}

inline VertexAttributes& PolygonEngine::VAttributes(void)
{
  return _va;
}

inline void PolygonEngine::FillPoly(void)
{
  ClipPoly();
  if(_p1.Size())
    _fillpoly(&VAttributes());
}

inline void PolygonEngine::DrawPoly(void)
{
  int i,j;
  ClipPoly();
  for(i=0; i<_p1.Size(); i++)
    {
      j = i + 1;
      if(j == _p1.Size())
	j = 0;

      _drawline(&VAttributes(), _p1[i], _p1[j]);
    }
}

inline void PolygonEngine::SetPixel(ScrCoord x, ScrCoord y)
{
  if((x >= _clip._x1) && (x <= _clip._x2) &&
     (y >= _clip._y1) && (y <= _clip._y2))
    _setpixel(&VAttributes(),x,y);
}

inline void PolygonEngine::SetPixel(ScrCoord x, ScrCoord y, ColorIndex c)
{
  VAttributes().c = c;
  SetPixel(x,y);
}

inline void PolygonEngine::SetPixel(ScrCoord x, ScrCoord y, 
				    ColorComponent r, ColorComponent g, ColorComponent b)
{
  VAttributes().r = r;
  VAttributes().g = g;
  VAttributes().b = b;
  SetPixel(x,y);
}


#endif

