/*
 *
 * sinus.h
 *
 */


#ifndef SINUS_H
#define SINUS_H

#define SIN_SHIFT 15
#define SIN_MASK  255

extern long sintab[];
extern long costab[];

typedef int Angle;

#define SIN0(x) (sintab[(x) & SIN_MASK])
#define SIN(x)  ((long)((x) >= 0 ? SIN0(x) : -SIN0(-x)))

#define COS0(x) (costab[(x) & SIN_MASK])
#define COS(x)  ((long)((x) >= 0 ? COS0(x) :  COS0(-x)))


inline int Sin(Angle x) { return SIN(x); }
inline int Cos(Angle x) { return COS(x); }


/*
#define SIN0(x) (sintab[x])
#define SIN1(x) ((x) & 256 ?  SIN0(511-(x)) : SIN0(x))
#define SIN2(x) ((x) & 512 ? -SIN1((x)-512) : SIN1(x))
#define SIN3(x) SIN2((x) & 1023)
#define SIN(x) ((x)>0 ? SIN3(x) : -SIN3(-x))

#define COS(x) SIN(x + 256)
*/

#endif
