###
###
#
# Global definitions for Makefiles.
# This file is included by all TAGL Makefiles.
# Modify it according to your system.
#
###
###

# TAGL distribution tree

TAGL_ROOT = $(HOME)/hp/tagl-2.0
TAGL_INC  = ./include -I../include -I../../include -I/usr/include/X11R6
TAGL_LIB  = ../lib
TAGL_BIN  = ../bin

# C and C++ compiler

CXX=g++
CC=gcc
LDXX=g++
LD=gcc

# makedepends doesn't know C++ include path
# let it blank if you don't know and ignore
# messages while 'make dep' (it does not matter ...).

ALL_INCLUDES=-I/usr/include/X11R6

# optimize flags

OPTIMIZE=-O6 -funroll-loops -fPIC

# X11 and SVGA special stuff.
# Add here include and linking path if needed.
# Remove -DX_SHM if your system does not have MIT X SHM.
# Remove -lvga if you don't have Linux SVGAlib.

CCX11=
LDX11=-L/usr/lib/X11R6 -lX11 -lXext

CCSVGA=
LDSVGA=

# Add -DEBUG here for compiling
# assertion checks (slower).

CCOPT=$(OPTIMIZE)
CXXOPT=$(OPTIMIZE)

LDOPT=
LDXXOPT=-lm

# Remove SVGAgport if you don't have Linux SVGAlib.
# Remove Xgport if you only have Linux SVGAlib.
# If you devellop polygon engines, add them here.

SRCGPORTS=Xgport.C
SRCPOLYENGS=polyeng_8.C polyeng_555.C polyeng_24.C

GPORTS=Xgport.o 
POLYENGS=polyeng_8.o polyeng_555.o polyeng_24.o

LDGPORTS=$(TAGL_LIB)/Xgport.o 
LDPOLYENGS=$(TAGL_LIB)/polyeng_8.o $(TAGL_LIB)/polyeng_555.o \
           $(TAGL_LIB)/polyeng_24.o

#
# You should not need to modify this file 
# beyond this point.
#

LDGPORT=-L$(TAGL_LIB) -ltagl $(LDGPORTS) $(LDX11) $(LDSVGA)
LDPOLYENG=$(LDPOLYENGS)

.SUFFIXES: .o .c .C

.C.o:
	$(CXX) -c $(CXXOPT) -I$(TAGL_INC) $<

.c.o:
	$(CC) -c $(CCOPT) $<

nothing:
	@echo make what ?

love:
	@echo Making love - do not disturb


dep:
	makedepend $(ALL_INCLUDES) -I$(TAGL_INC) $(SRC)
	
clean:
	rm -f *.o *~ core*
