
/*
 *
 * polyeng.C
 *
 */


#include "polyeng_555.h"
#include <string.h>


////
////
//
// Virtual constructor stuff
//
////
////


PolygonEngine *MakePolygonEngine_555(GraphicPort *GP, int verb)
{
  PolygonEngine *PE = new PolygonEngine_555(GP,verb);

  if(PE->BitsPerPixel() != 15 ||
     PE->RedMask()      != (31 << 10) ||
     PE->GreenMask()    != (31 << 5)  ||
     PE->BlueMask()     != 31          )
    {
      delete PE;
      return NULL;
    }
  return PE;
}

class PolygonEngine_555Stub
{
public:
  PolygonEngine_555Stub(void) 
    { 
      PolygonEngine_VC.Register(MakePolygonEngine_555); 
    } 
};

static PolygonEngine_555Stub Dummy;


PolyFun PolygonEngine_555::_fillpoly_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_555::FillPoly_c,
//     0      0      0      0      0      1
  PolygonEngine_555::FillPoly_rgb,
//     0      0      0      0      1      0
  PolygonEngine_555::FillPoly_C,
//     0      0      0      0      1      1
  PolygonEngine_555::FillPoly_RGB,
//     0      0      0      1      0      0
  PolygonEngine_555::FillPoly_c_D,
//     0      0      0      1      0      1
  PolygonEngine_555::FillPoly_rgb,
//     0      0      0      1      1      0
  PolygonEngine_555::FillPoly_C_D,
//     0      0      0      1      1      1
  PolygonEngine_555::FillPoly_RGB_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_555::FillPoly_c_Z,
//     0      0      1      0      0      1
  PolygonEngine_555::FillPoly_rgb_Z,
//     0      0      1      0      1      0
  PolygonEngine_555::FillPoly_C_Z,
//     0      0      1      0      1      1
  PolygonEngine_555::FillPoly_RGB_Z,
//     0      0      1      1      0      0
  PolygonEngine_555::FillPoly_c_Z_D,
//     0      0      1      1      0      1
  PolygonEngine_555::FillPoly_rgb_Z,
//     0      0      1      1      1      0
  PolygonEngine_555::FillPoly_C_Z_D,
//     0      0      1      1      1      1
  PolygonEngine_555::FillPoly_RGB_Z_D
};


LineFun PolygonEngine_555::_drawline_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_555::DrawLine_c,
//     0      0      0      0      0      1
  PolygonEngine_555::DrawLine_rgb,
//     0      0      0      0      1      0
  PolygonEngine_555::DrawLine_C,
//     0      0      0      0      1      1
  PolygonEngine_555::DrawLine_RGB,
//     0      0      0      1      0      0
  PolygonEngine_555::DrawLine_c_D,
//     0      0      0      1      0      1
  PolygonEngine_555::DrawLine_rgb,
//     0      0      0      1      1      0
  PolygonEngine_555::DrawLine_C_D,
//     0      0      0      1      1      1
  PolygonEngine_555::DrawLine_RGB_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_555::DrawLine_c_Z,
//     0      0      1      0      0      1
  PolygonEngine_555::DrawLine_rgb_Z,
//     0      0      1      0      1      0
  PolygonEngine_555::DrawLine_C_Z,
//     0      0      1      0      1      1
  PolygonEngine_555::DrawLine_RGB_Z,
//     0      0      1      1      0      0
  PolygonEngine_555::DrawLine_c_Z_D,
//     0      0      1      1      0      1
  PolygonEngine_555::DrawLine_rgb_Z,
//     0      0      1      1      1      0
  PolygonEngine_555::DrawLine_C_Z_D,
//     0      0      1      1      1      1
  PolygonEngine_555::DrawLine_RGB_Z_D
};


PixelFun PolygonEngine_555::_setpixel_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_555::SetPixel_c,
//     0      0      0      0      0      1
  PolygonEngine_555::SetPixel_rgb,
//     0      0      0      0      1      0
  PolygonEngine_555::SetPixel_c,
//     0      0      0      0      1      1
  PolygonEngine_555::SetPixel_rgb,
//     0      0      0      1      0      0
  PolygonEngine_555::SetPixel_c_D,
//     0      0      0      1      0      1
  PolygonEngine_555::SetPixel_rgb_D,
//     0      0      0      1      1      0
  PolygonEngine_555::SetPixel_c_D,
//     0      0      0      1      1      1
  PolygonEngine_555::SetPixel_rgb_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_555::SetPixel_c_z,
//     0      0      1      0      0      1
  PolygonEngine_555::SetPixel_rgb_z,
//     0      0      1      0      1      0
  PolygonEngine_555::SetPixel_c_z,
//     0      0      1      0      1      1
  PolygonEngine_555::SetPixel_rgb_z,
//     0      0      1      1      0      0
  PolygonEngine_555::SetPixel_c_z_D,
//     0      0      1      1      0      1
  PolygonEngine_555::SetPixel_rgb_z,
//     0      0      1      1      1      0
  PolygonEngine_555::SetPixel_c_z_D,
//     0      0      1      1      1      1
  PolygonEngine_555::SetPixel_rgb_z_D
};



PolygonEngine_555::PolygonEngine_555(GraphicPort *gp, int verb) : PolygonEngine(gp, verb)
{
  _proc_name = "PolygonEngine_555";
  Verbose(verb);
  (*this)[MSG_INFO] << "hello, world!\n";
  CommitAttributes();
}

PolygonEngine_555::~PolygonEngine_555(void)
{
}

void PolygonEngine_555::CommitAttributes(void)
{
  if(Attributes().GetAll() > 15)
    {
      (*this)[MSG_ERROR] << "invalid attributes\n";
      return;
    }

  _fillpoly = _fillpoly_array[Attributes().GetAll()];
  _drawline = _drawline_array[Attributes().GetAll()];
  _setpixel = _setpixel_array[Attributes().GetAll()];

}  

//
//
// Polygon filling routines
//
//

#define GENFILL_RGB_MAX    255
#define GENFILL_RGB_SHIFT  3
#define GENFILL_NAME       PolygonEngine_555::FillPoly_rgb
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_HEAD       ColorComponent r = MIN(VA->r,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorCode cw = b       |  \
                                         (g << 5) |  \
                                         (r << 10);
#define GENFILL_SCAN       for(x=x1; x<=x2; x++,*(graph_ptr++) = cw);

#include "genfill.h"


#define GENFILL_Z
#define GENFILL_RGB_MAX    255
#define GENFILL_RGB_SHIFT  3
#define GENFILL_NAME       PolygonEngine_555::FillPoly_rgb_Z
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_HEAD       ColorComponent r = MIN(VA->r,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorCode cw = b       |  \
                                         (g << 5) |  \
                                         (r << 10);
#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = cw;                          \
			       }

#include "genfill.h"


#define GENFILL_RGB
#define GENFILL_RGB_MAX    255
#define GENFILL_RGB_SHIFT  3
#define GENFILL_NAME       PolygonEngine_555::FillPoly_RGB
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_DO_PIXEL   *graph_ptr = (((r << 5) | g) << 5) | b;

#include "genfill.h"


#define GENFILL_Z
#define GENFILL_RGB
#define GENFILL_RGB_MAX    255
#define GENFILL_RGB_SHIFT  3
#define GENFILL_NAME       PolygonEngine_555::FillPoly_RGB_Z
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = (((r << 5) | g) << 5) | b;   \
			       }
#include "genfill.h"



#define GENFILL_C
#define GENFILL_C_MAX      (255 << D_SHIFT)
#define GENFILL_C_SHIFT    D_SHIFT
#define GENFILL_NAME       PolygonEngine_555::FillPoly_C
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_DO_PIXEL   *graph_ptr = _truecolormap[c];

#include "genfill.h"



#define GENFILL_Z
#define GENFILL_C
#define GENFILL_C_MAX      (255 << D_SHIFT)
#define GENFILL_C_SHIFT    D_SHIFT
#define GENFILL_NAME       PolygonEngine_555::FillPoly_C_Z
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = _truecolormap[c];            \
			       }

#include "genfill.h"


#define GENFILL_NAME   PolygonEngine_555::FillPoly_c
#define GENFILL_PIXEL  PixelValue15
#define GENFILL_HEAD   ColorCode cw = _truecolormap[VA->c >> D_SHIFT];
#define GENFILL_SCAN   for(x=x1; x<=x2; x++,*(graph_ptr++) = cw);

#include "genfill.h"


#define GENFILL_Z
#define GENFILL_NAME   PolygonEngine_555::FillPoly_c_Z
#define GENFILL_PIXEL  PixelValue15
#define GENFILL_HEAD   ColorCode cw = _truecolormap[VA->c >> D_SHIFT];
#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = cw;                          \
			       }
#include "genfill.h"


#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  0
#define GENFILL_NAME     PolygonEngine_555::FillPoly_C_D
#define GENFILL_PIXEL    PixelValue15
#define GENFILL_HEAD     ColorCode cw;
#define GENFILL_DO_PIXEL cw = c >> D_SHIFT;                                                  \
                         if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                            cw++;                                                            \
			 *graph_ptr = _truecolormap[cw];     
#include "genfill.h"			 


#define GENFILL_NAME     PolygonEngine_555::FillPoly_c_D
#define GENFILL_PIXEL    PixelValue15
#define GENFILL_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENFILL_DO_PIXEL if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _truecolormap[cw+1];                                \
                         else                                                                \
			    *graph_ptr = _truecolormap[cw];
#include "genfill.h"



#define GENFILL_Z
#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  0
#define GENFILL_NAME     PolygonEngine_555::FillPoly_C_Z_D
#define GENFILL_PIXEL    PixelValue15
#define GENFILL_HEAD     ColorCode cw;
#define GENFILL_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      cw = c >> D_SHIFT;         \
                           if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                              cw++;                                                            \
			      *graph_ptr = _truecolormap[cw];                                  \
			    }
#include "genfill.h"



#define GENFILL_Z
#define GENFILL_NAME     PolygonEngine_555::FillPoly_c_Z_D
#define GENFILL_PIXEL    PixelValue15
#define GENFILL_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENFILL_DO_PIXEL if(z < *z_ptr)                                                      \
                         {                                                                   \
			   *z_ptr = z;                                                       \
                         if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _truecolormap[cw+1];                                \
                         else                                                                \
			    *graph_ptr = _truecolormap[cw];                                  \
		         }
#include "genfill.h"


#define GENFILL_RGB
#define GENFILL_RGB_MAX    (31 << 3)
#define GENFILL_PRECISION_OVERRIDE
#define GENFILL_RGB_SHIFT  1
#define GENFILL_NAME       PolygonEngine_555::FillPoly_RGB_D
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_HEAD       ColorCode cw; \
                           int treshold;
#define GENFILL_DO_PIXEL   cw = ((r >> D_SHIFT) << 10) |                                \
                                ((g >> D_SHIFT) << 5 ) |                                \
                                ((b >> D_SHIFT)      );                                 \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << 10);                                       \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << 5);                                        \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw ++;                                                 \
                                                                                        \
	                   *graph_ptr = cw;


#include "genfill.h"


#define GENFILL_Z
#define GENFILL_RGB
#define GENFILL_RGB_MAX    (31 << 3)
#define GENFILL_PRECISION_OVERRIDE
#define GENFILL_RGB_SHIFT  1
#define GENFILL_NAME       PolygonEngine_555::FillPoly_RGB_Z_D
#define GENFILL_PIXEL      PixelValue15
#define GENFILL_HEAD       ColorCode cw; \
                           int treshold;
#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                               \
                           {                                                            \
                           *z_ptr = z;                                                  \
                           cw = ((r >> D_SHIFT) << 10) |                                \
                                ((g >> D_SHIFT) << 5 ) |                                \
                                ((b >> D_SHIFT)      );                                 \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << 10);                                       \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << 5);                                        \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw ++;                                                 \
                                                                                        \
	                   *graph_ptr = cw;                                             \
                           }


#include "genfill.h"

//
//
// Line drawing functions
//
//



#define GENDRAW_RGB_MAX    255
#define GENDRAW_RGB_SHIFT  3
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_rgb
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_HEAD       ColorComponent r = MIN(VA->r,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorCode cw = b       |  \
                                         (g << 5) |  \
                                         (r << 10);
#define GENDRAW_DO_PIXEL   *graph_ptr = cw;

#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_RGB_MAX    255
#define GENDRAW_RGB_SHIFT  3
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_rgb_Z
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_HEAD       ColorComponent r = MIN(VA->r,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorCode cw = b       |  \
                                         (g << 5) |  \
                                         (r << 10);
#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = cw;                          \
			       }

#include "gendraw.h"


#define GENDRAW_RGB
#define GENDRAW_RGB_MAX    255
#define GENDRAW_RGB_SHIFT  3
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_RGB
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_DO_PIXEL   *graph_ptr = (((r << 5) | g) << 5) | b;

#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_RGB
#define GENDRAW_RGB_MAX    255
#define GENDRAW_RGB_SHIFT  3
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_RGB_Z
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = (((r << 5) | g) << 5) | b;   \
			       }
#include "gendraw.h"



#define GENDRAW_C
#define GENDRAW_C_MAX      (255 << D_SHIFT)
#define GENDRAW_C_SHIFT    D_SHIFT
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_C
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_DO_PIXEL   *graph_ptr = _truecolormap[c];

#include "gendraw.h"



#define GENDRAW_Z
#define GENDRAW_C
#define GENDRAW_C_MAX      (255 << D_SHIFT)
#define GENDRAW_C_SHIFT    D_SHIFT
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_C_Z
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = _truecolormap[c];            \
			       }

#include "gendraw.h"


#define GENDRAW_NAME     PolygonEngine_555::DrawLine_c
#define GENDRAW_PIXEL    PixelValue15
#define GENDRAW_HEAD     ColorCode cw = _truecolormap[VA->c >> D_SHIFT];
#define GENDRAW_DO_PIXEL *graph_ptr = cw;

#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_c_Z
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_HEAD       ColorCode cw = _truecolormap[VA->c >> D_SHIFT];
#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                  \
                               {                                           \
                                 *z_ptr = z;                               \
                                 *graph_ptr = cw;                          \
			       }
#include "gendraw.h"


#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  0
#define GENDRAW_NAME     PolygonEngine_555::DrawLine_C_D
#define GENDRAW_PIXEL    PixelValue15
#define GENDRAW_HEAD     ColorCode cw;
#define GENDRAW_DO_PIXEL cw = c >> D_SHIFT;                                                  \
                         if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                            cw++;                                                            \
			 *graph_ptr = _truecolormap[cw];     
#include "gendraw.h"			 


#define GENDRAW_NAME     PolygonEngine_555::DrawLine_c_D
#define GENDRAW_PIXEL    PixelValue15
#define GENDRAW_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENDRAW_DO_PIXEL if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _truecolormap[cw+1];                                \
                         else                                                                \
			    *graph_ptr = _truecolormap[cw];
#include "gendraw.h"



#define GENDRAW_Z
#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  0
#define GENDRAW_NAME     PolygonEngine_555::DrawLine_C_Z_D
#define GENDRAW_PIXEL    PixelValue15
#define GENDRAW_HEAD     ColorCode cw;
#define GENDRAW_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      cw = c >> D_SHIFT;         \
                           if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                              cw++;                                                            \
			      *graph_ptr = _truecolormap[cw];                                  \
			    }
#include "gendraw.h"



#define GENDRAW_Z
#define GENDRAW_NAME     PolygonEngine_555::DrawLine_c_Z_D
#define GENDRAW_PIXEL    PixelValue15
#define GENDRAW_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENDRAW_DO_PIXEL if(z < *z_ptr)                                                      \
                         {                                                                   \
			   *z_ptr = z;                                                       \
                         if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _truecolormap[cw+1];                                \
                         else                                                                \
			    *graph_ptr = _truecolormap[cw];                                  \
		         }
#include "gendraw.h"


#define GENDRAW_RGB
#define GENDRAW_RGB_MAX    (31 << 3)
#define GENDRAW_PRECISION_OVERRIDE
#define GENDRAW_RGB_SHIFT  1
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_RGB_D
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_HEAD       ColorCode cw; \
                           int treshold;
#define GENDRAW_DO_PIXEL   cw = ((r >> D_SHIFT) << 10) |                                \
                                ((g >> D_SHIFT) << 5 ) |                                \
                                ((b >> D_SHIFT)      );                                 \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << 10);                                       \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << 5);                                        \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw ++;                                                 \
                                                                                        \
	                   *graph_ptr = cw;


#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_RGB
#define GENDRAW_RGB_MAX    (31 << 3)
#define GENDRAW_PRECISION_OVERRIDE
#define GENDRAW_RGB_SHIFT  1
#define GENDRAW_NAME       PolygonEngine_555::DrawLine_RGB_Z_D
#define GENDRAW_PIXEL      PixelValue15
#define GENDRAW_HEAD       ColorCode cw; \
                           int treshold;
#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                               \
                           {                                                            \
                           *z_ptr = z;                                                  \
                           cw = ((r >> D_SHIFT) << 10) |                                \
                                ((g >> D_SHIFT) << 5 ) |                                \
                                ((b >> D_SHIFT)      );                                 \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << 10);                                       \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << 5);                                        \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw ++;                                                 \
                                                                                        \
	                   *graph_ptr = cw;                                             \
                           }


#include "gendraw.h"

//
//
// Pixel routines
//
//


void PolygonEngine_555::SetPixel_rgb(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  PixelValue15 *graph_ptr = (PixelValue15 *)
    (_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

  ColorComponent r = MIN(VA->r,255) >> 3; 
  ColorComponent g = MIN(VA->g,255) >> 3; 
  ColorComponent b = MIN(VA->b,255) >> 3; 

  ColorCode cw = b | (g << 5) | (r << 10);

  *graph_ptr = cw;
}


void PolygonEngine_555::SetPixel_rgb_z(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ZCoord       *z_ptr     = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      PixelValue15 *graph_ptr = (PixelValue15 *)
	(_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

      ColorComponent r = MIN(VA->r,255) >> 3; 
      ColorComponent g = MIN(VA->g,255) >> 3; 
      ColorComponent b = MIN(VA->b,255) >> 3; 

      ColorCode cw = b | (g << 5) | (r << 10);

      *graph_ptr = cw;
    }
}


void PolygonEngine_555::SetPixel_rgb_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  PixelValue15 *graph_ptr = (PixelValue15 *)
    (_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));


  ColorComponent r = MIN(VA->r, 31 << 3);
  ColorComponent g = MIN(VA->g, 31 << 3);
  ColorComponent b = MIN(VA->b, 31 << 3);

  ColorCode cw = ((r >> 3) << 10) |                                
                 ((g >> 3) << 5 ) |                                
		 ((b >> 3)      );                                 

  int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

  if(((r & 7) << 1) > treshold)                                  
    cw += (1 << 10);                                       
      
  if(((g & 7) << 1) > treshold)                                  
    cw += (1 << 5);                                        
  
  if(((b & 7) << 1) > treshold)                                  
    cw ++;

  *graph_ptr = cw;

}


void PolygonEngine_555::SetPixel_rgb_z_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{

  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      PixelValue15 *graph_ptr = (PixelValue15 *)
	(_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

      ColorComponent r = MIN(VA->r, 31 << 3);
      ColorComponent g = MIN(VA->g, 31 << 3);
      ColorComponent b = MIN(VA->b, 31 << 3);

      ColorCode cw = ((r >> 3) << 10) |                                
	             ((g >> 3) << 5 ) |                                
	             ((b >> 3)      );                                 

      int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

      if(((r & 7) << 1) > treshold)                                  
	cw += (1 << 10);                                       
      
      if(((g & 7) << 1) > treshold)                                  
	cw += (1 << 5);                                        
  
      if(((b & 7) << 1) > treshold)                                  
	cw ++;

      *graph_ptr = cw;
    }
}

void PolygonEngine_555::SetPixel_c(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  PixelValue15 *graph_ptr = (PixelValue15 *)
    (_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

  *graph_ptr = _truecolormap[VA->c >> D_SHIFT];
}

void PolygonEngine_555::SetPixel_c_z(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      PixelValue15 *graph_ptr = (PixelValue15 *)
	(_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

      *graph_ptr = _truecolormap[VA->c >> D_SHIFT];
    }
}

void PolygonEngine_555::SetPixel_c_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  PixelValue15 *graph_ptr = (PixelValue15 *)
    (_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

  ColorCode  c = MIN(VA->c, 255 << D_SHIFT);
  ColorCode cc = c >> D_SHIFT;

  int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

  if((c & D_MASK) > treshold)
    cc++;

  *graph_ptr = _truecolormap[cc];
}



void PolygonEngine_555::SetPixel_c_z_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{

  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      PixelValue15 *graph_ptr = (PixelValue15 *)
	(_graph_mem + y * _bytes_per_line + x * sizeof(PixelValue15));

      ColorCode  c = MIN(VA->c, 255 << D_SHIFT);
      ColorCode cc = c >> D_SHIFT;
      
      int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

      if((c & D_MASK) > treshold)
	cc++;

      *graph_ptr = _truecolormap[cc];
    }
}

