/*
 *
 * polyeng.h
 *
 */


// 15 bpp-555 driver
// R_mask = 31 << 10
// G_mask = 31 << 5
// B_mask = 31


#ifndef POLYENG_555_H
#define POLYENG_555_H

#include "polyeng.h"


class PolygonEngine_555 : public PolygonEngine
{

 public:
  PolygonEngine_555(GraphicPort *gp, int verbose_level = MSG_NONE);
  virtual ~PolygonEngine_555(void);
  virtual void CommitAttributes(void);

  static void FillPoly_c(VertexAttributes *);
  static void FillPoly_C(VertexAttributes *);

  static void FillPoly_c_D(VertexAttributes *);
  static void FillPoly_C_D(VertexAttributes *);

  static void FillPoly_rgb(VertexAttributes *);
  static void FillPoly_RGB(VertexAttributes *);

  static void FillPoly_c_Z(VertexAttributes *);
  static void FillPoly_C_Z(VertexAttributes *);

  static void FillPoly_c_Z_D(VertexAttributes *);
  static void FillPoly_C_Z_D(VertexAttributes *);

  static void FillPoly_rgb_Z(VertexAttributes *);
  static void FillPoly_RGB_Z(VertexAttributes *);

  static void FillPoly_RGB_Z_D(VertexAttributes *);
  static void FillPoly_RGB_D(VertexAttributes *);

  static void DrawLine_c(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_C(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_c_D(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_C_D(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_rgb(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_RGB(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_c_Z(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_C_Z(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_c_Z_D(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_C_Z_D(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_rgb_Z(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_RGB_Z(VertexAttributes *, Vertex *, Vertex *);

  static void DrawLine_RGB_Z_D(VertexAttributes *, Vertex *, Vertex *);
  static void DrawLine_RGB_D(VertexAttributes *, Vertex *, Vertex *);

  static void SetPixel_c(VertexAttributes *, ScrCoord, ScrCoord);
  static void SetPixel_c_D(VertexAttributes *, ScrCoord, ScrCoord);

  static void SetPixel_rgb(VertexAttributes *, ScrCoord, ScrCoord);
  static void SetPixel_rgb_D(VertexAttributes *, ScrCoord, ScrCoord);

  static void SetPixel_c_z(VertexAttributes *, ScrCoord, ScrCoord);
  static void SetPixel_c_z_D(VertexAttributes *, ScrCoord, ScrCoord);

  static void SetPixel_rgb_z(VertexAttributes *, ScrCoord, ScrCoord);
  static void SetPixel_rgb_z_D(VertexAttributes *, ScrCoord, ScrCoord);

  static PolyFun  _fillpoly_array[16];
  static LineFun  _drawline_array[16];
  static PixelFun _setpixel_array[16];

};

#include "polyeng_555_i.h"

#endif
