
/*
 *
 * polyeng.C
 *
 */


#include "polyeng_8.h"
#include <string.h>


PolyFun PolygonEngine_8::_fillpoly_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_8::FillPoly_c,
//     0      0      0      0      0      1
  PolygonEngine_8::FillPoly_rgb_D,
//     0      0      0      0      1      0
  PolygonEngine_8::FillPoly_C,
//     0      0      0      0      1      1
  PolygonEngine_8::FillPoly_RGB_D,
//     0      0      0      1      0      0
  PolygonEngine_8::FillPoly_c_D,
//     0      0      0      1      0      1
  PolygonEngine_8::FillPoly_rgb_D,
//     0      0      0      1      1      0
  PolygonEngine_8::FillPoly_C_D,
//     0      0      0      1      1      1
  PolygonEngine_8::FillPoly_RGB_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_8::FillPoly_c_Z,
//     0      0      1      0      0      1
  PolygonEngine_8::FillPoly_rgb_Z_D,
//     0      0      1      0      1      0
  PolygonEngine_8::FillPoly_C_Z,
//     0      0      1      0      1      1
  PolygonEngine_8::FillPoly_RGB_Z_D,
//     0      0      1      1      0      0
  PolygonEngine_8::FillPoly_c_Z_D,
//     0      0      1      1      0      1
  PolygonEngine_8::FillPoly_rgb_Z_D,
//     0      0      1      1      1      0
  PolygonEngine_8::FillPoly_C_Z_D,
//     0      0      1      1      1      1
  PolygonEngine_8::FillPoly_RGB_Z_D
};


LineFun PolygonEngine_8::_drawline_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_8::DrawLine_c,
//     0      0      0      0      0      1
  PolygonEngine_8::DrawLine_rgb_D,
//     0      0      0      0      1      0
  PolygonEngine_8::DrawLine_C,
//     0      0      0      0      1      1
  PolygonEngine_8::DrawLine_RGB_D,
//     0      0      0      1      0      0
  PolygonEngine_8::DrawLine_c_D,
//     0      0      0      1      0      1
  PolygonEngine_8::DrawLine_rgb_D,
//     0      0      0      1      1      0
  PolygonEngine_8::DrawLine_C_D,
//     0      0      0      1      1      1
  PolygonEngine_8::DrawLine_RGB_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_8::DrawLine_c_Z,
//     0      0      1      0      0      1
  PolygonEngine_8::DrawLine_rgb_Z_D,
//     0      0      1      0      1      0
  PolygonEngine_8::DrawLine_C_Z,
//     0      0      1      0      1      1
  PolygonEngine_8::DrawLine_RGB_Z_D,
//     0      0      1      1      0      0
  PolygonEngine_8::DrawLine_c_Z_D,
//     0      0      1      1      0      1
  PolygonEngine_8::DrawLine_rgb_Z_D,
//     0      0      1      1      1      0
  PolygonEngine_8::DrawLine_C_Z_D,
//     0      0      1      1      1      1
  PolygonEngine_8::DrawLine_RGB_Z_D
};



PixelFun PolygonEngine_8::_setpixel_array[16] =
{
//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      0      0      0      0
  PolygonEngine_8::SetPixel_c,
//     0      0      0      0      0      1
  PolygonEngine_8::SetPixel_rgb_D,
//     0      0      0      0      1      0
  PolygonEngine_8::SetPixel_c,
//     0      0      0      0      1      1
  PolygonEngine_8::SetPixel_rgb_D,
//     0      0      0      1      0      0
  PolygonEngine_8::SetPixel_c_D,
//     0      0      0      1      0      1
  PolygonEngine_8::SetPixel_rgb_D,
//     0      0      0      1      1      0
  PolygonEngine_8::SetPixel_c_D,
//     0      0      0      1      1      1
  PolygonEngine_8::SetPixel_rgb_D,

//  TEXTURE ALPHA ZBUFFER DITHER GOURAUD RGB
//
//     0      0      1      0      0      0
  PolygonEngine_8::SetPixel_c_z,
//     0      0      1      0      0      1
  PolygonEngine_8::SetPixel_rgb_z_D,
//     0      0      1      0      1      0
  PolygonEngine_8::SetPixel_c_z,
//     0      0      1      0      1      1
  PolygonEngine_8::SetPixel_rgb_z_D,
//     0      0      1      1      0      0
  PolygonEngine_8::SetPixel_c_z_D,
//     0      0      1      1      0      1
  PolygonEngine_8::SetPixel_rgb_z_D,
//     0      0      1      1      1      0
  PolygonEngine_8::SetPixel_c_z_D,
//     0      0      1      1      1      1
  PolygonEngine_8::SetPixel_rgb_z_D
};




PolygonEngine_8::PolygonEngine_8(GraphicPort *gp, int verb) : PolygonEngine(gp,verb)
{
  _proc_name = "PolygonEngine_8";
  Verbose(verb);
  (*this)[MSG_INFO] << "hello, world!\n";
  CommitAttributes();
}

PolygonEngine_8::~PolygonEngine_8(void)
{
}

void PolygonEngine_8::CommitAttributes(void)
{
  if(Attributes().GetAll() > 15)
    {
      (*this)[MSG_ERROR] << "invalid attributes\n";
      return;
    }

  _fillpoly = _fillpoly_array[Attributes().GetAll()];
  _drawline = _drawline_array[Attributes().GetAll()];
  _setpixel = _setpixel_array[Attributes().GetAll()];
}


#define GENFILL_NAME     PolygonEngine_8::FillPoly_c
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorIndex c = _colormap[VA->c >> D_SHIFT];
#define GENFILL_SCAN     memset(graph_ptr, c, dx);
#include "genfill.h"


#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  D_SHIFT
#define GENFILL_NAME     PolygonEngine_8::FillPoly_C
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_DO_PIXEL *graph_ptr = _colormap[c];
#include "genfill.h"


#define GENFILL_NAME     PolygonEngine_8::FillPoly_c_D
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorIndex c = VA->c;                                               \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENFILL_DO_PIXEL if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _colormap[cw+1];                                    \
                         else                                                                \
			    *graph_ptr = _colormap[cw];
#include "genfill.h"

#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  0
#define GENFILL_NAME     PolygonEngine_8::FillPoly_C_D
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorCode cw;
#define GENFILL_DO_PIXEL cw = c >> D_SHIFT;                                                  \
                         if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                            cw++;                                                            \
			 *graph_ptr = _colormap[cw];                                         
#include "genfill.h"			 


#define GENFILL_RGB
#define GENFILL_RGB_MAX    (128 + 64)
#define GENFILL_RGB_SHIFT  2
#define GENFILL_NAME       PolygonEngine_8::FillPoly_RGB_D
#define GENFILL_PIXEL      ColorIndex
#define GENFILL_HEAD       ColorCode cw;        \
                           int       treshold; 
#define GENFILL_DO_PIXEL   cw = ((r >> D_SHIFT) << R_SHIFT) |                           \
                                ((g >> D_SHIFT) << G_SHIFT) |                           \
                                ((b >> D_SHIFT) << B_SHIFT);                            \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];

#include "genfill.h"

#define GENFILL_RGB_MAX    (128 + 64)
#define GENFILL_RGB_SHIFT  2
#define GENFILL_NAME       PolygonEngine_8::FillPoly_rgb_D
#define GENFILL_PIXEL      ColorIndex
#define GENFILL_HEAD       ColorComponent r = MIN(VA->r,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                                                                                            \
                           ColorCode c  = ((r >> D_SHIFT) << R_SHIFT) |                     \
                                          ((g >> D_SHIFT) << G_SHIFT) |                     \
                                          ((b >> D_SHIFT) << B_SHIFT);                      \
                                                                                            \
			   ColorComponent rm = r & D_MASK;                                  \
			   ColorComponent gm = g & D_MASK;                                  \
			   ColorComponent bm = b & D_MASK;                                  \
                           ColorCode cw;                                                    \
                           int treshold;

#define GENFILL_DO_PIXEL   cw = c;                                                      \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((rm) > treshold)                                          \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((gm) > treshold)                                          \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((bm) > treshold)                                          \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];

#include "genfill.h"



#define GENFILL_Z
#define GENFILL_NAME     PolygonEngine_8::FillPoly_c_Z
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorCode c = _colormap[VA->c >> D_SHIFT];
#define GENFILL_DO_PIXEL if(z < *z_ptr)               \
                            {                         \
			      *z_ptr = z;             \
			      *graph_ptr = c;         \
			    }
#include "genfill.h"

#define GENFILL_Z
#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  D_SHIFT
#define GENFILL_NAME     PolygonEngine_8::FillPoly_C_Z
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      *graph_ptr = _colormap[c]; \
			    }
#include "genfill.h"

#define GENFILL_Z
#define GENFILL_C
#define GENFILL_C_MAX    (255 << D_SHIFT)
#define GENFILL_C_SHIFT  0
#define GENFILL_NAME     PolygonEngine_8::FillPoly_C_Z_D
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorCode cw;
#define GENFILL_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      cw = c >> D_SHIFT;         \
                           if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                              cw++;                                                            \
			      *graph_ptr = _colormap[cw];                                      \
			    }
#include "genfill.h"


#define GENFILL_Z
#define GENFILL_NAME     PolygonEngine_8::FillPoly_c_Z_D
#define GENFILL_PIXEL    ColorIndex
#define GENFILL_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENFILL_DO_PIXEL if(z < *z_ptr)                                                      \
                         {                                                                   \
			   *z_ptr = z;                                                       \
                         if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _colormap[cw+1];                                    \
                         else                                                                \
			    *graph_ptr = _colormap[cw];                                      \
		         }
#include "genfill.h"


#define GENFILL_RGB
#define GENFILL_Z
#define GENFILL_RGB_MAX    (128 + 64)
#define GENFILL_RGB_SHIFT  2
#define GENFILL_NAME       PolygonEngine_8::FillPoly_RGB_Z_D
#define GENFILL_PIXEL      ColorIndex
#define GENFILL_HEAD       ColorCode cw;      \
                           int       treshold;
#define GENFILL_DO_PIXEL if(z < *z_ptr)                                                 \
                           {                                                            \
			   *z_ptr = z;                                                  \
                           cw = ((r >> D_SHIFT) << R_SHIFT) |                           \
                                ((g >> D_SHIFT) << G_SHIFT) |                           \
                                ((b >> D_SHIFT) << B_SHIFT);                            \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];                                  \
			   }

#include "genfill.h"


#define GENFILL_Z
#define GENFILL_RGB_MAX    (128 + 64)
#define GENFILL_RGB_SHIFT  2
#define GENFILL_NAME       PolygonEngine_8::FillPoly_rgb_Z_D
#define GENFILL_PIXEL      ColorIndex
#define GENFILL_HEAD       ColorComponent r = MIN(VA->r,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENFILL_RGB_MAX) >> GENFILL_RGB_SHIFT; \
                                                                                            \
                           ColorCode c  = ((r >> D_SHIFT) << R_SHIFT) |                     \
                                          ((g >> D_SHIFT) << G_SHIFT) |                     \
                                          ((b >> D_SHIFT) << B_SHIFT);                      \
                                                                                            \
			   ColorComponent rm = r & D_MASK;                                  \
			   ColorComponent gm = g & D_MASK;                                  \
			   ColorComponent bm = b & D_MASK;                                  \
			   ColorCode cw;                                                    \
			   int treshold;

#define GENFILL_DO_PIXEL   if(z < *z_ptr)                                               \
                           {                                                            \
                           *z_ptr = z;							\
                           cw = c;                                                      \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((rm) > treshold)                                          \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((gm) > treshold)                                          \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((bm) > treshold)                                          \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];                                  \
                           }

#include "genfill.h"


//
//
// Draw routines
//
//


#define GENDRAW_NAME     PolygonEngine_8::DrawLine_c
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorIndex c = _colormap[VA->c >> D_SHIFT];
#define GENDRAW_DO_PIXEL *graph_ptr = c;
#include "gendraw.h"


#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  D_SHIFT
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_C
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_DO_PIXEL *graph_ptr = _colormap[c];
#include "gendraw.h"


#define GENDRAW_NAME     PolygonEngine_8::DrawLine_c_D
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorIndex c = VA->c;                                               \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENDRAW_DO_PIXEL if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _colormap[cw+1];                                    \
                         else                                                                \
			    *graph_ptr = _colormap[cw];
#include "gendraw.h"

#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  0
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_C_D
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorCode cw;
#define GENDRAW_DO_PIXEL cw = c >> D_SHIFT;                                                  \
                         if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                            cw++;                                                            \
			 *graph_ptr = _colormap[cw];                                         
#include "gendraw.h"			 


#define GENDRAW_RGB
#define GENDRAW_RGB_MAX    (128 + 64)
#define GENDRAW_RGB_SHIFT  2
#define GENDRAW_NAME       PolygonEngine_8::DrawLine_RGB_D
#define GENDRAW_PIXEL      ColorIndex
#define GENDRAW_HEAD       ColorCode cw;        \
                           int       treshold; 
#define GENDRAW_DO_PIXEL   cw = ((r >> D_SHIFT) << R_SHIFT) |                           \
                                ((g >> D_SHIFT) << G_SHIFT) |                           \
                                ((b >> D_SHIFT) << B_SHIFT);                            \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];

#include "gendraw.h"

#define GENDRAW_RGB_MAX    (128 + 64)
#define GENDRAW_RGB_SHIFT  2
#define GENDRAW_NAME       PolygonEngine_8::DrawLine_rgb_D
#define GENDRAW_PIXEL      ColorIndex
#define GENDRAW_HEAD       ColorComponent r = MIN(VA->r,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                                                                                            \
                           ColorCode c  = ((r >> D_SHIFT) << R_SHIFT) |                     \
                                          ((g >> D_SHIFT) << G_SHIFT) |                     \
                                          ((b >> D_SHIFT) << B_SHIFT);                      \
                                                                                            \
			   ColorComponent rm = r & D_MASK;                                  \
			   ColorComponent gm = g & D_MASK;                                  \
			   ColorComponent bm = b & D_MASK;                                  \
                           ColorCode cw;                                                    \
                           int treshold;

#define GENDRAW_DO_PIXEL   cw = c;                                                      \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((rm) > treshold)                                          \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((gm) > treshold)                                          \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((bm) > treshold)                                          \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];

#include "gendraw.h"



#define GENDRAW_Z
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_c_Z
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorCode c = _colormap[VA->c >> D_SHIFT];
#define GENDRAW_DO_PIXEL if(z < *z_ptr)               \
                            {                         \
			      *z_ptr = z;             \
			      *graph_ptr = c;         \
			    }
#include "gendraw.h"

#define GENDRAW_Z
#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  D_SHIFT
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_C_Z
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      *graph_ptr = _colormap[c]; \
			    }
#include "gendraw.h"

#define GENDRAW_Z
#define GENDRAW_C
#define GENDRAW_C_MAX    (255 << D_SHIFT)
#define GENDRAW_C_SHIFT  0
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_C_Z_D
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorCode cw;
#define GENDRAW_DO_PIXEL if(z < *z_ptr)                  \
                            {                            \
			      *z_ptr = z;                \
			      cw = c >> D_SHIFT;         \
                           if((c & D_MASK) > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] ) \
                              cw++;                                                            \
			      *graph_ptr = _colormap[cw];                                      \
			    }
#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_NAME     PolygonEngine_8::DrawLine_c_Z_D
#define GENDRAW_PIXEL    ColorIndex
#define GENDRAW_HEAD     ColorCode c = VA->c;                                                \
                         c = (c > (255 << D_SHIFT)) ? (255 << D_SHIFT) : c;                  \
			 ColorCode cw = c >> D_SHIFT;                                        \
                         ColorCode cm = c & D_MASK;

#define GENDRAW_DO_PIXEL if(z < *z_ptr)                                                      \
                         {                                                                   \
			   *z_ptr = z;                                                       \
                         if(cm > D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)] )           \
			    *graph_ptr = _colormap[cw+1];                                    \
                         else                                                                \
			    *graph_ptr = _colormap[cw];                                      \
		         }
#include "gendraw.h"


#define GENDRAW_RGB
#define GENDRAW_Z
#define GENDRAW_RGB_MAX    (128 + 64)
#define GENDRAW_RGB_SHIFT  2
#define GENDRAW_NAME       PolygonEngine_8::DrawLine_RGB_Z_D
#define GENDRAW_PIXEL      ColorIndex
#define GENDRAW_HEAD       ColorCode cw;      \
                           int       treshold;
#define GENDRAW_DO_PIXEL if(z < *z_ptr)                                                 \
                           {                                                            \
			   *z_ptr = z;                                                  \
                           cw = ((r >> D_SHIFT) << R_SHIFT) |                           \
                                ((g >> D_SHIFT) << G_SHIFT) |                           \
                                ((b >> D_SHIFT) << B_SHIFT);                            \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((r & D_MASK) > treshold)                                  \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((g & D_MASK) > treshold)                                  \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((b & D_MASK) > treshold)                                  \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];                                  \
			   }

#include "gendraw.h"


#define GENDRAW_Z
#define GENDRAW_RGB_MAX    (128 + 64)
#define GENDRAW_RGB_SHIFT  2
#define GENDRAW_NAME       PolygonEngine_8::DrawLine_rgb_Z_D
#define GENDRAW_PIXEL      ColorIndex
#define GENDRAW_HEAD       ColorComponent r = MIN(VA->r,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent g = MIN(VA->g,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                           ColorComponent b = MIN(VA->b,GENDRAW_RGB_MAX) >> GENDRAW_RGB_SHIFT; \
                                                                                            \
                           ColorCode c  = ((r >> D_SHIFT) << R_SHIFT) |                     \
                                          ((g >> D_SHIFT) << G_SHIFT) |                     \
                                          ((b >> D_SHIFT) << B_SHIFT);                      \
                                                                                            \
			   ColorComponent rm = r & D_MASK;                                  \
			   ColorComponent gm = g & D_MASK;                                  \
			   ColorComponent bm = b & D_MASK;                                  \
			   ColorCode cw;                                                    \
			   int treshold;

#define GENDRAW_DO_PIXEL   if(z < *z_ptr)                                               \
                           {                                                            \
                           *z_ptr = z;							\
                           cw = c;                                                      \
                           treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  \
                                                                                        \
                           if((rm) > treshold)                                          \
                                 cw += (1 << R_SHIFT);                                  \
                                                                                        \
                           if((gm) > treshold)                                          \
                                 cw += (1 << G_SHIFT);                                  \
                                                                                        \
                           if((bm) > treshold)                                          \
                                 cw += (1 << B_SHIFT);                                  \
                                                                                        \
	                   *graph_ptr = _colormap[cw];                                  \
                           }

#include "gendraw.h"

//
//
// SetPixel routines
//
//


void PolygonEngine_8::SetPixel_rgb_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;

  ColorComponent r = MIN(VA->r, 3 << 6);
  ColorComponent g = MIN(VA->g, 3 << 6);
  ColorComponent b = MIN(VA->b, 3 << 6);

  ColorCode cw = ((r >> 6) << 4) |                                
                 ((g >> 6) << 2) |                                
		 ((b >> 6)      );                                 

  int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

  if(((r & 63) >> 2) > treshold)                                  
    cw += (1 << 4);                                       
      
  if(((g & 63) >> 2) > treshold)                                  
    cw += (1 << 2);                                        
  
  if(((b & 63) >> 2) > treshold)                                  
    cw ++;

  *graph_ptr = _colormap[cw];

}


void PolygonEngine_8::SetPixel_rgb_z_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{

  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;

      ColorComponent r = MIN(VA->r, 3 << 6);
      ColorComponent g = MIN(VA->g, 3 << 6);
      ColorComponent b = MIN(VA->b, 3 << 6);

      ColorCode cw = ((r >> 6) << 4) |                                
	             ((g >> 6) << 2) |                                
	             ((b >> 6)      );                                 

      int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

      if(((r & 63) >> 2) > treshold)                                  
	cw += (1 << 4);                                       
      
      if(((g & 63) >> 2) > treshold)                                  
	cw += (1 << 2);                                        
  
      if(((b & 63) >> 2) > treshold)                                  
	cw ++;

      *graph_ptr = _colormap[cw];

    }
}


void PolygonEngine_8::SetPixel_c(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;
  *graph_ptr = _colormap[VA->c >> D_SHIFT];
}

void PolygonEngine_8::SetPixel_c_z(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;
      ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;
      *graph_ptr = _colormap[VA->c >> D_SHIFT];
    }
}

void PolygonEngine_8::SetPixel_c_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{
  ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;

  ColorCode  c = MIN(VA->c, 255 << D_SHIFT);
  ColorCode cc = c >> D_SHIFT;

  int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

  if((c & D_MASK) > treshold)
    cc++;

  *graph_ptr = _colormap[cc];
}



void PolygonEngine_8::SetPixel_c_z_D(VertexAttributes *VA, ScrCoord x, ScrCoord y)
{

  ZCoord   *z_ptr  = _z_mem + y * _width + x;

  if(VA->z < *z_ptr)
    {
      *z_ptr = VA->z;

      ColorIndex *graph_ptr = _graph_mem + y * _bytes_per_line + x;

      ColorCode  c = MIN(VA->c, 255 << D_SHIFT);
      ColorCode cc = c >> D_SHIFT;
      
      int treshold = D4[(x & D_PMASK) + ((y & D_PMASK) << D_PSHIFT)];  

      if((c & D_MASK) > treshold)
	cc++;

      *graph_ptr = _colormap[cc];
    }
}




////
////
//
// Virtual constructor stuff
//
////
////


PolygonEngine *MakePolygonEngine_8(GraphicPort *GP, int verb)
{
  PolygonEngine *PE = new PolygonEngine_8(GP,verb);

  if(PE->BitsPerPixel() != 8)
    {
      delete PE;
      return NULL;
    }
  return PE;
}

class PolygonEngine_8Stub
{
public:
  PolygonEngine_8Stub(void) 
    { 
      PolygonEngine_VC.Register(MakePolygonEngine_8); 
    } 
};

static PolygonEngine_8Stub Dummy;

