/*
 *
 * gport.C
 *
 */

#include "gport.h"

// A virtual destructor for GraphicPorts

GraphicPort::~GraphicPort(void)
{
}


int GraphicPort_VCC::_entries = 0;


GraphicPort_VCC::GraphicPort_VCC(void)
{
}

void GraphicPort_VCC::Register(const GraphicPort_MakeFun make, const int flags)
{
  assert(_entries < VC_ENTRIES);
  _entry[_entries].make    = make;
  _entry[_entries].flags   = flags;
  _entries++;

#ifdef EBUG
  cerr << "[TAGL_VC] GraphicPort_VCC::register() called - " << _entries << " entries\n";
#endif
}

GraphicPort* GraphicPort_VCC::Make(char* name, ScrCoord width, ScrCoord height, 
				   int verb)
{
  int i;
  GraphicPort *GP = NULL;
  for(i=0; i<_entries; i++)
    if((!_entry[i].flags) && (GP = _entry[i].make(name, width, height, verb)))
      return GP;

  for(i=0; i<_entries; i++)
    if((_entry[i].flags) && (GP = _entry[i].make(name, width, height, verb)))
      return GP;

#ifdef EBUG
  cerr << "[TAGL_VC] GraphicPort_VCC:: No constructor available for this technology\n";
#endif
  return NULL;
}

GraphicPort_VCC GraphicPort_VC;

GraphicPort* MakeGraphicPort(char* name, ScrCoord width, ScrCoord height, int verb)
{
  return GraphicPort_VC.Make(name, width, height, verb);
}



